blob: c9a11d15d228479158d5fe429d52ef7e0decb457 [file] [log] [blame]
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +02001#!/bin/sh
2#
3# link vmlinux
4#
5# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_INIT) and
6# $(KBUILD_VMLINUX_MAIN). Most are built-in.o files from top-level directories
7# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
8# Ordering when linking is important, and $(KBUILD_VMLINUX_INIT) must be first.
9#
10# vmlinux
11# ^
12# |
13# +-< $(KBUILD_VMLINUX_INIT)
14# | +--< init/version.o + more
15# |
16# +--< $(KBUILD_VMLINUX_MAIN)
17# | +--< drivers/built-in.o mm/built-in.o + more
18# |
19# +-< ${kallsymso} (see description in KALLSYMS section)
20#
21# vmlinux version (uname -v) cannot be updated during normal
22# descending-into-subdirs phase since we do not yet know if we need to
23# update vmlinux.
24# Therefore this step is delayed until just before final link of vmlinux.
25#
26# System.map is generated to document addresses of all kernel symbols
27
28# Error out on error
29set -e
30
31# Nice output in kbuild format
32# Will be supressed by "make -s"
33info()
34{
35 if [ "${quiet}" != "silent_" ]; then
36 printf " %-7s %s\n" ${1} ${2}
37 fi
38}
39
40# Link of vmlinux.o used for section mismatch analysis
41# ${1} output file
42modpost_link()
43{
44 ${LD} ${LDFLAGS} -r -o ${1} ${KBUILD_VMLINUX_INIT} \
45 --start-group ${KBUILD_VMLINUX_MAIN} --end-group
46}
47
48# Link of vmlinux
49# ${1} - optional extra .o files
50# ${2} - output file
51vmlinux_link()
52{
53 local lds="${objtree}/${KBUILD_LDS}"
54
55 if [ "${SRCARCH}" != "um" ]; then
56 ${LD} ${LDFLAGS} ${LDFLAGS_vmlinux} -o ${2} \
57 -T ${lds} ${KBUILD_VMLINUX_INIT} \
58 --start-group ${KBUILD_VMLINUX_MAIN} --end-group ${1}
59 else
60 ${CC} ${CFLAGS_vmlinux} -o ${2} \
61 -Wl,-T,${lds} ${KBUILD_VMLINUX_INIT} \
62 -Wl,--start-group \
63 ${KBUILD_VMLINUX_MAIN} \
64 -Wl,--end-group \
65 -lutil ${1}
66 rm -f linux
67 fi
68}
69
70
71# Create ${2} .o file with all symbols from the ${1} object file
72kallsyms()
73{
74 info KSYM ${2}
75 local kallsymopt;
76
Rusty Russellb92021b2013-03-15 15:04:17 +103077 if [ -n "${CONFIG_HAVE_UNDERSCORE_SYMBOL_PREFIX}" ]; then
78 kallsymopt="${kallsymopt} --symbol-prefix=_"
James Hogan6895f972012-09-06 22:11:25 +010079 fi
80
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020081 if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
James Hogan6895f972012-09-06 22:11:25 +010082 kallsymopt="${kallsymopt} --all-symbols"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020083 fi
84
Ming Lei7122c3e2013-12-10 16:46:29 +103085 if [ -n "${CONFIG_ARM}" ] && [ -n "${CONFIG_PAGE_OFFSET}" ]; then
86 kallsymopt="${kallsymopt} --page-offset=$CONFIG_PAGE_OFFSET"
87 fi
Ming Leif6537f22013-11-02 09:11:33 +103088
Rusty Russellc6bda7c2014-03-17 14:05:46 +103089 if [ -n "${CONFIG_X86_64}" ]; then
90 kallsymopt="${kallsymopt} --absolute-percpu"
91 fi
92
Sam Ravnborg00e6c28c2012-05-08 19:53:46 +020093 local aflags="${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
94 ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS}"
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +020095
96 ${NM} -n ${1} | \
97 scripts/kallsyms ${kallsymopt} | \
98 ${CC} ${aflags} -c -o ${2} -x assembler-with-cpp -
99}
100
101# Create map file with all symbols from ${1}
102# See mksymap for additional details
103mksysmap()
104{
105 ${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
106}
107
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700108sortextable()
109{
110 ${objtree}/scripts/sortextable ${1}
111}
112
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200113# Delete output files in case of error
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200114cleanup()
115{
116 rm -f .old_version
117 rm -f .tmp_System.map
118 rm -f .tmp_kallsyms*
119 rm -f .tmp_version
120 rm -f .tmp_vmlinux*
121 rm -f System.map
122 rm -f vmlinux
123 rm -f vmlinux.o
124}
125
Sylvain BERTRANDab160db2015-05-07 00:36:04 +0000126on_exit()
127{
128 if [ $? -ne 0 ]; then
129 cleanup
130 fi
131}
132trap on_exit EXIT
133
134on_signals()
135{
136 exit 1
137}
138trap on_signals HUP INT QUIT TERM
139
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200140#
141#
142# Use "make V=1" to debug this script
143case "${KBUILD_VERBOSE}" in
144*1*)
145 set -x
146 ;;
147esac
148
149if [ "$1" = "clean" ]; then
150 cleanup
151 exit 0
152fi
153
154# We need access to CONFIG_ symbols
Michal Marek423a8152013-02-25 13:47:53 +0100155case "${KCONFIG_CONFIG}" in
156*/*)
157 . "${KCONFIG_CONFIG}"
158 ;;
159*)
160 # Force using a file from the current directory
161 . "./${KCONFIG_CONFIG}"
162esac
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200163
164#link vmlinux.o
165info LD vmlinux.o
166modpost_link vmlinux.o
167
168# modpost vmlinux.o to check for section mismatches
169${MAKE} -f "${srctree}/scripts/Makefile.modpost" vmlinux.o
170
171# Update version
172info GEN .version
173if [ ! -r .version ]; then
174 rm -f .version;
175 echo 1 >.version;
176else
177 mv .version .old_version;
178 expr 0$(cat .old_version) + 1 >.version;
179fi;
180
181# final build of init/
182${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init
183
184kallsymso=""
185kallsyms_vmlinux=""
186if [ -n "${CONFIG_KALLSYMS}" ]; then
187
188 # kallsyms support
189 # Generate section listing all symbols and add it into vmlinux
190 # It's a three step process:
191 # 1) Link .tmp_vmlinux1 so it has all symbols and sections,
192 # but __kallsyms is empty.
193 # Running kallsyms on that gives us .tmp_kallsyms1.o with
194 # the right size
195 # 2) Link .tmp_vmlinux2 so it now has a __kallsyms section of
196 # the right size, but due to the added section, some
197 # addresses have shifted.
198 # From here, we generate a correct .tmp_kallsyms2.o
199 # 2a) We may use an extra pass as this has been necessary to
200 # woraround some alignment related bugs.
201 # KALLSYMS_EXTRA_PASS=1 is used to trigger this.
202 # 3) The correct ${kallsymso} is linked into the final vmlinux.
203 #
204 # a) Verify that the System.map from vmlinux matches the map from
205 # ${kallsymso}.
206
207 kallsymso=.tmp_kallsyms2.o
208 kallsyms_vmlinux=.tmp_vmlinux2
209
210 # step 1
211 vmlinux_link "" .tmp_vmlinux1
212 kallsyms .tmp_vmlinux1 .tmp_kallsyms1.o
213
214 # step 2
215 vmlinux_link .tmp_kallsyms1.o .tmp_vmlinux2
216 kallsyms .tmp_vmlinux2 .tmp_kallsyms2.o
217
218 # step 2a
219 if [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
220 kallsymso=.tmp_kallsyms3.o
221 kallsyms_vmlinux=.tmp_vmlinux3
222
223 vmlinux_link .tmp_kallsyms2.o .tmp_vmlinux3
224
225 kallsyms .tmp_vmlinux3 .tmp_kallsyms3.o
226 fi
227fi
228
229info LD vmlinux
230vmlinux_link "${kallsymso}" vmlinux
231
Linus Torvalds1347a2ce2012-05-28 10:32:28 -0700232if [ -n "${CONFIG_BUILDTIME_EXTABLE_SORT}" ]; then
233 info SORTEX vmlinux
234 sortextable vmlinux
235fi
236
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200237info SYSMAP System.map
238mksysmap vmlinux System.map
239
240# step a (see comment above)
241if [ -n "${CONFIG_KALLSYMS}" ]; then
242 mksysmap ${kallsyms_vmlinux} .tmp_System.map
243
244 if ! cmp -s System.map .tmp_System.map; then
Michal Marek5369f552012-07-07 23:04:40 +0200245 echo >&2 Inconsistent kallsyms data
Michal Marek367e43c2012-08-10 11:55:11 +0200246 echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
Sam Ravnborg1f2bfbd2012-05-05 10:18:41 +0200247 exit 1
248 fi
249fi
250
251# We made a new kernel - delete old version file
252rm -f .old_version